import 'package:openpay_flutter/model/open_pay_base_model.dart';
import 'package:openpay_flutter/utils/openpay_client.dart';

abstract class OpenPayBaseService<T,R extends OpenPayBaseModel>
{

  OpenPayClient _httpClient;
  String get resourceName;

  OpenPayBaseService(this._httpClient);
  
  String getEndpoint(){
    var merchandid =  _httpClient.apiMerchandId;
    return  "$merchandid/$resourceName" ;
  }

  Future<T> create(R entity) async {
    String  endpoint = getEndpoint();
    await _httpClient.post(endpoint, entity);
  }

  Future<T> update(R entity){
    String  endpoint = getEndpoint();
    _httpClient.put(endpoint, entity);
  }


  Future<T> get(String reference){
    String  endpoint = getEndpoint();
    _httpClient.get(endpoint);
  }


  Future<T> delete(String reference){
    String  endpoint = getEndpoint();
    _httpClient.delete(endpoint);
  }

  Future<T> getList(String reference){
    String  endpoint = getEndpoint();
    _httpClient.get(endpoint);
  }




    
  
}
